5 PRINT CHR$(26)
31 'DESIGN OF HELICAL ANTENNAS BASED ON "ANTENNAS" BY DR. JOHN D. KRAUS, W8JK
35 'PROGRAM WRITTEN BY W.G. SMITH, W9LRG.  PUBLISHED IN "QST", DEC. 1984.
40 PRINT TAB(26);"DESIGN OF A HELICAL ANTENNA"
50 PRINT : PRINT 
60 INPUT "CENTER FREQUENCY (MHz) = ";F
65 PI=3.14159 : K=3.2808
70 W=INT((3E+08/(F*1E+06))*100)/100
71 WF=INT((W*K)*100)/100
72 W1=WF*12
75 PRINT 
76 PRINT "SELECT A VALUE FOR THE CIRCUMFERENCE (C LAMBDA) IN WAVELENGTHS"
77 PRINT "VALUES NORMALLY RANGE FROM ABOUT 0.9 TO 1.20"
80 INPUT "C LAMBDA = ";CL
81 CF=INT(CL*WF*100)/100
85 PRINT : INPUT "NUMBER OF TURNS = ";N
86 PRINT : PRINT "SELECT THE PITCH ANGLE (IN DEGREES) OF THE HELIX"
87 PRINT "NORMAL ANGLES ARE BETWEEN 12 AND 15 DEGREES"
90 INPUT "PITCH ANGLE = ";A
91 PRINT : PRINT 
100 AR=A/57.2959
110 S=CL*TAN(AR)
112 SM=(INT(S*W*100))/100
116 SF=(INT(SM*K*100))/100
117 S1=SF*12
120 L=INT((SM/SIN(AR))*100)/100
131 LF=INT(L*K*100)/100
132 L1=LF*12
135 NS=N*SM
141 NF=INT(NS*K*100)/100
145 D=INT(CL*W*100/PI)/100
146 DF=INT(D*K*100)/100
147 D1=DF*12
150 SL=S
160 BP=INT(52/(CL*SQR(N*SL)))
170 BN=INT(115/(CL*SQR(N*SL)))
180 G=INT(15*CL^2*N*SL)
190 R=140*CL
225 GN=INT(10*(LOG(G)/LOG(10))+.5)
260 PRINT TAB(24);"SUMMARY"
265 PRINT 
270 PRINT "FREQUENCY =";F;"MHz"
280 PRINT "CIRCUM. OF HELIX (C LAMBDA) =";CL;"WAVELENGTHS =";CF;"FEET"
290 PRINT "NO. TURNS =";N
291 PRINT "PITCH ANGLE =";A;"DEGREES
292 PRINT "AXIAL LENGTH =";NF;"FEET"
293 PRINT "ANTENNA GAIN =";G;"=";GN;"dBi"
295 PRINT 
300 PRINT TAB(31);"METERS";TAB(42);"FEET";TAB(52);"INCHES"
305 PRINT "WAVELENGTH";TAB(31);W;TAB(41);WF;TAB(51);W1
310 PRINT "SPACING BETWEEN TURNS";TAB(32);SM;TAB(41);SF;TAB(51);S1
315 PRINT "HELIX DIAMETER";TAB(32);D;TAB(41);DF;TAB(51);D1
320 PRINT "LENGTH OF TURN";TAB(31);L;TAB(41);LF;TAB(51);L1
330 PRINT 
340 PRINT "BEAM WIDTH (HALF POWER) =";BP;"DEGREES"
350 PRINT "BEAM WIDTH (FIRST NULL) =";BN;"DEGRRES"
355 PRINT 
360 PRINT "TERMINAL RESISTANCE =";R;"OHMS"
530 PRINT : PRINT : PRINT 
535 INPUT "DO YOU WANT TO DESIGN ANOTHER ANTENNA (Y/N)";Y$
540 IF Y$="Y" OR Y$="y" THEN PRINT CHR$(26) : GOTO 60
550 END
 
535 INPUT "DO YOU 