/*
%CC1 $1.C -X
%CLINK $1 -N
%DELETE $1.CRL
*/
/*********************************************************************
*                               C                                    *
**********************************************************************
*                  COPYRIGHT 1983 EUGENE H. MALLORY                  *
*********************************************************************/
#INCLUDE "BDSCIO.h"
#DEFINE BCOUNT 200
CHAR string[MAXLINE];
CHAR fname[MAXLINE],fname2[MAXLINE];
CHAR c;
INT fd1,fd2;
FILE fcb1;
CHAR barray[BCOUNT][MAXLINE];
CHAR buffer[128];
INT bctr,flag;
MAIN(argc,argv)
CHAR **argv;
INT argc;
  BEGIN
    CHAR *n,fname[MAXLINE];
    FILE fcb;
    INT i,j,len,flag;
    IF (argc == 1)
      THEN
	IF (fopen("CNAME.$$$",fcb) == -1)
	  THEN
	    printf("E: Unable to open file CNAME.$$$.\n");
	    exit(0);
	  ENDIF
	fgets(fname,fcb);
	fname[strlen(fname)-1] = 0;
	strcpy(fname2,fname);
	FOR (i=argc-2;i>0;i--) argv[i+1] = argv[i];
	argv[1] = fname2;
	argc++;
	fclose(fcb);
	printf("  C %s\n",argv[1]);
      ENDIF
    IF (argc >= 2)
      THEN
	fcreat("CNAME.$$$",fcb);
	fputs(argv[1],fcb);
	fputs("\n\032",fcb);
	fflush(fcb);
	fclose(fcb);
	strcpy(fname,argv[1]);
      ENDIF

    strcat(fname,".C");

    fd1 = fopen(fname,fcb1);
    IF (fd1 == ERROR)
      THEN
	printf("C: Cannot open file %s.\n",fname);
	exit(0);
      ENDIF
    flag = bctr = 0;
    WHILE (fgets(string,fcb1))
      LOOP
	len = strlen(string);
	string[len-1] = 0;
	IF (string[0] == '%')
	  THEN
	    flag = 1;
	    linecopy(barray[bctr++],&string[1],argv,argc,0);
	  ENDIF
	ELSE IF (flag == 1) BREAK;
	IF (bctr == BCOUNT)
	  THEN
	    printf("C: Batch file too big.");
	    exit(0);
	  ENDIF
      ENDLOOP
/*	SUBSTITUTED ARGUMENTS ARE NOW IN BARRAY */ 

    writesub: 
    fd2 = open("A:$$$.SUB",2);
    IF (fd2 == -1)
      THEN
	fd2 = creat("A:$$$.SUB");
      ENDIF
    ELSE
      THEN
	DO
	  LOOP
	    flag = read(fd2,buffer,1);
	    IF (flag == -1)
	      THEN
		printf("C: Unable to append to A:$$$.SUB.");
		exit(0);
	      ENDIF
	  ENDLOOP
	WHILE (flag);
      ENDIF
    /* Now $$.sub should be opened correctly */
    WHILE (bctr--)
      LOOP
	FOR (i=0;i<128;i++) buffer[i] = 0x1a;
	strcpy(&buffer[1],barray[bctr]);
	buffer[0] = strlen(barray[bctr]);
	i = write(fd2,buffer,1);
	IF (i != 1)
	  THEN
	    printf("%S: Unable to write A:$$$.SUB.",argv[0]);
	    exit(0);
	  ENDIF
      ENDLOOP
    close(fd2);
    bios(1);
  END

FUNCTION linecopy(dest,source,argv,argc,bias)
CHAR *dest,*source,**argv;
INT argc,bias;
  BEGIN
    INT i;
    CHAR c,tempstr[MAXLINE];
    IF (*source == '*') *source = ';';
    WHILE (c = *source++) 
      LOOP
	IF (c == '$' && isdigit(*source))
	  THEN
	    i = *source-'0'+bias;
	    IF (i < argc)
	      THEN
		strcpy(dest,argv[i]);
		dest += strlen(argv[i]);
	      ENDIF
	    source++;
	  ENDIF
	ELSE IF (c == '$' && *source == '*')
	  THEN
	    FOR (i=1+bias;i<argc;i++)
	      LOOP
		IF (i < argc)
		  THEN
		    strcpy(dest,argv[i]);
		    strcat(dest," ");
		    dest += strlen(argv[i])+1;
		  ENDIF
	      ENDLOOP
	    source++;
	  ENDIF
	ELSE IF (c == '$' && *source == '#')
	  THEN
	    sprintf(tempstr,"%d",argc-bias);
	    strcpy(dest,tempstr);
	    dest += strlen(tempstr);
	    source++;
	  ENDIF
	ELSE IF (c == '$' && *source == '$')
	  THEN
	    source++;
	    *dest++ = c;
	  ENDIF
	ELSE IF (c == '^' && isalpha(*source))
	  THEN
	    *dest++ = toupper(*source)-0x40;
	    source++;
	  ENDIF
	ELSE
	  THEN
	    *dest++ = c;
	  ENDIF
      ENDLOOP
    *dest = 0;
  END
