/*
%CC1 $1.C -X -E5000
%CLINK $1 DIO WILDEXP -N -S
%DELETE $1.CRL 
*/
/*********************************************************************
*                               HELP                                 *
**********************************************************************
*                  COPYRIGHT 1983 EUGENE H. MALLORY                  *
*********************************************************************/
#INCLUDE "BDSCIO.H"
#INCLUDE "DIO.H"
#DEFINE MENUCOUNT 120
#DEFINE NOCONTINUE 1 /* Set to 1 if you want to exit at end of section */
CHAR menutext[MENUCOUNT][MAXLINE];
CHAR *menuptrs[MENUCOUNT];
CHAR **menuv,*cprompt,*lprompt;
INT menuctr,mindex;
CHAR string[MAXLINE];
CHAR fname[MAXLINE];
CHAR c;
INT fd1;
CHAR fcb1[BUFSIZ];
INT string_compare();

MAIN(argc,argv)
CHAR **argv;
INT argc;

  BEGIN
    INT i,j,menuflag;
    CHAR *fvector[3];
    CHAR **fvectorp;
    CHAR *disk;
    INT diskno,vctr;
    dioinit(&argc,argv);
    menuflag = 0;
    cprompt = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lprompt = "abcdefghijklmnopqrstuvwxyz";
    IF (argc != 2)
      THEN
	disk = "ABCDEFGHIJKL";
	vctr = 3;
	diskno = BDOS(25);
	IF (!diskno) vctr = 2;
	fvector[0] = "DUMMY";
	fvector[1] = "?:*.HLP";
	fvector[1][0] = disk[diskno];
	fvector[2] = "A:*.HLP";
	fvectorp = fvector;
	wildexp(&vctr,&fvectorp);
	qsort(&fvectorp[1],vctr-1,2,&string_compare);
	fvectorp++;
	filemenu:
	i = menu(vctr-1,fvectorp,cprompt);
	IF (i == -1) goto exithelp;
	strcpy(fname,fvectorp[i]);
	fd1 = fopen(fname,fcb1);
	IF (fd1 == ERROR)
	error("HELP: Unable to open %s",fname);
	menuflag = 1;
      ENDIF
    ELSE
      THEN
	strcpy(fname,argv[1]);
	strcat(fname,".hlp");
	fd1 = fopen(fname,fcb1);
	IF (fd1==ERROR) 
	  THEN
	    strcpy(fname,"a:");
	    strcat(fname,argv[1]);
	    strcat(fname,".hlp");
	    fd1 = fopen(fname,fcb1);
	  ENDIF
	IF (fd1==ERROR) 
	  THEN
	    dioflush();
	    error("HELP: Unable to find help for: %s. \N",fname);
	  ENDIF
      ENDIF
    IF (!fgets(string,fcb1))
      THEN
	dioflush();
	error("HELP: Help file %s empty.",fname);
      ENDIF
    menuctr = 0;
    FOR (i=0;i<MENUCOUNT;i++) menuptrs[i] = &menutext[i];
    menuv = &menuptrs[0];
    IF (string[0] == ':')
      THEN
	/* Non indexed file, build index */
	DO
	  LOOP
	    string[strlen(string)-1] = 0;
	    IF (string[0] == ':')
	    strcpy(menutext[menuctr++],string);
	    IF (menuctr == MENUCOUNT)
	    BREAK;
	  ENDLOOP
	WHILE (fgets(string,fcb1));
	fclose(fcb1);
	fopen(fname,fcb1);
	fgets(string,fcb1);
      ENDIF
    ELSE
      THEN
	/* Indexed file, build index */
	DO
	  LOOP
	    string[strlen(string)-1] = 0;
	    strcpy(menutext[menuctr++],string);
	    IF (!fgets(string,fcb1) || menuctr == MENUCOUNT)
	      THEN
		/* No colons and no index. */
		fclose(fcb1);
		fopen(fname,fcb1);
		typef("\n\014");
		string[0] = ':';
		fgets(&string[1],fcb1);
		helprint(!menuflag);
		IF (menuflag) goto filemenu;
		goto exithelp;
	      ENDIF
	  ENDLOOP
	WHILE (string[0] != ':');
      ENDIF
/****************************************************************
*  	Now, index is built and the first line read		*
*	past the index.						*
****************************************************************/
    again:
    IF (menuctr == 1) /* if only one choice */
      THEN
	helprint(0);
	IF (menuflag) goto filemenu;
	ELSE goto exithelp;
      ENDIF
    mindex=menu(menuctr,menuv,lprompt);
    IF (mindex == -1 && menuflag) goto filemenu;
    IF (mindex == -1) goto exithelp;
    WHILE (mindex)
      LOOP
	IF (!fgets(string,fcb1))
	  THEN
	    error("HELP: Ran off end of help file while searching.");
	  ENDIF
	IF (string[0] == ':') mindex--;
      ENDLOOP
    helprint(0);
    fclose(fcb1);
    fopen(fname,fcb1);
    WHILE (fgets(string,fcb1))
      LOOP
	IF (string[0] == ':') BREAK;
      ENDLOOP
    goto again;
    exithelp:
    fclose(fcb1);
    dioflush();
  END

helprint(exitflag)
INT exitflag;
  BEGIN
    CHAR c;
    INT lctr,noteof;
    printmore:
    IF (DIOOUT) puts(&string[1]);
    typef("%s",&string[1]);
    lctr = 1;
    WHILE (noteof = fgets(string,fcb1))
      LOOP
	IF (string[0] == ':') BREAK;
	lctr++;
	IF ((string[0] == '\014' || string[0] == ';' || lctr == 21))
	  THEN
	    lctr = 0;
	    typef("\n(More available, hit CR to continue, ESC to quit.)\n");
	    c = BDOS(1)&0xff;
	    IF (c == '\003') exit(0);  	/* CTL C */
	    IF (c == '\033') goto quit;
	    typef("\n\014");
	    IF (string[0] == '\014' || string[0] == ';') 
	      THEN
		IF (DIOOUT) puts(&string[1]);
		typef("%s",&string[1]);
		lctr++;
	      ENDIF
	    ELSE
	      THEN
		IF (DIOOUT) puts(string);
		typef("%s",string);
	      ENDIF
	    CONTINUE;
	  ENDIF
	IF (DIOOUT) puts(string);
	typef("%s",string);
      ENDLOOP
    IF (exitflag) goto quit;
    IF (!noteof) 
    typef("\n(End of file, CR to return to menu.)\n");
    ELSE IF (NOCONTINUE)
    typef("\n(End of section, CR to return to menu.)\n");
    ELSE
    typef("\n(End of section, CR to continue, ESC to quit.)\n");
    c = BDOS(1)&0xff;
    IF (c == '\003') exit(0);  	/* CTL C */
    IF (c == '\033' || !noteof || NOCONTINUE) 
      THEN
	quit: 
	return;
      ENDIF
    typef("\n\014");
    goto printmore;
  END

menu(icounter,strings,prompt)
CHAR **strings,*prompt;
INT icounter;
  BEGIN
    INT max,bias,i,j;
    bias = 0;
    lup:
    typef("\n\014");
    IF ((icounter-bias) > 26) max = 26;
    ELSE max = icounter-bias;
    FOR (i=0;i<(max+1)/2;i++)
      LOOP
	typef("%c) %s",prompt[i],strings[i+bias]);
	IF (i+bias+(max+1)/2 < icounter)
	  THEN
	    FOR (j=0;j<=37-strlen(strings[i+bias]);j++) typef(" ");
	    typef("%c) %s\n",
	    prompt[i+(max+1)/2],
	    strings[i+bias+(max+1)/2]);
	  ENDIF
	ELSE typef("\n");
      ENDLOOP
    typef("\n\n");
    IF (icounter > bias+26)
    typef("More selections are available.\n");
    typef("Type selection, ESC to exit, CR for more, - to backup :");
    c = bdos(1);
    typef("char is %x\n\014",c);
    IF (c == '\003') exit(0);  	/* CTL C */
    IF (c == '\033') RETURN -1;  	/* ESC   */
    IF (c == '\r' && (icounter > bias+26)) bias += 26;
    ELSE IF (c == '\r' && (icounter <= bias+26)) bias = 0;
    IF (c == '-') bias -= 26;
    IF (bias == -26) bias = icounter-26;
    IF (bias < 0) bias = 0;
    IF (!isalpha(c)) goto lup;
    FOR (i=0;toupper(c)!=toupper(prompt[i]);i++);
    IF (i>=max) goto lup;
    IF (i+bias >= icounter) goto lup;
    RETURN i+bias;
  END

INT string_compare(s,t)
CHAR **s, **t;
  BEGIN
    CHAR *s1, *t1;
    INT i;
    s1 = *s;
    t1 = *t;
    FOR (i=0;i<MAXLINE;i++)
      LOOP
	IF (t1[i] != s1[i]) 
	RETURN s1[i] - t1[i];
	IF (s1[i] == '\0') RETURN 0;
      ENDLOOP
    RETURN 0;
  END
