10 'FILTRESP is based on "Filter Response Program" by Richard Bain
20 'Published in "RF Design", Jan 1985
30 'Modified and converted to MBASIC by R. S. Stein, W6NBI, 1-12-85
40 PRINT CHR$(26)
50 ON ERROR GOTO 2310
60 PRINT TAB(28);"BUTTERWORTH AND CHEBYSHEV"
70 PRINT TAB(23);"FILTER ATTENUATION/FREQUENCY PROGRAM"
80 PRINT TAB(23);STRING$(36,"*")
90 PRINT TAB(10);"THIS PROGRAM CALCULATES ATTENUATION FOR A SPECIFIED FREQUENCY" 
100 PRINT TAB(20);"AND FREQUENCY FOR A SPECIFIED ATTENUATION" 
110 PRINT : PRINT "SELECT FREQUENCY UNITS:"
120 PRINT "   1 - Hz"
130 PRINT "   2 - kHz"
140 PRINT "   3 - MHz"
150 PRINT "   4 - GHz"
160 INPUT "YOUR CHOICE";HZ
170 PRINT 
180 PRINT "NOTE! - Always enter bandwidth and frequency in the same units."
190 PRINT "        Answers will then be in those units."
200 PRINT : INPUT "NUMBER OF POLES";NP
210 PRINT : PRINT "SELECT FILTER CONFIGURATION:"   
220 PRINT "   1 - BUTTERWORTH"
230 PRINT "   2 - CHEBYSHEV"
240 INPUT "YOUR CHOICE";NUM
250 IF NUM=2 THEN 1090
260 PRINT CHR$(26);TAB(27);"BUTTERWORTH FILTER ANALYSIS"
270 PRINT TAB(27);STRING$(27,"-")
280 PRINT : PRINT  "ENTER 3 dB CUTOFF FREQUENCY FOR LOWPASS AND HIGHPASS FILTERS"
290 INPUT  "OR 3 dB BANDWIDTH FOR BANDPASS AND BANDSTOP FILTERS           ",BW3
300 PRINT : PRINT "DO YOU WANT PROGRAM TO CALCULATE:"
310 PRINT "   1 - ATTENUATION FOR GIVEN FREQUENCY"
320 PRINT "   2 - FREQUENCY FOR GIVEN ATTENUATION"
330 INPUT "YOUR CHOICE";AORF
340 IF AORF=2 THEN 710
350 PRINT : PRINT "SELECT TYPE OF FILTER:"
360 PRINT "   1 - LOWPASS"
370 PRINT "   2 - BANDPASS"
380 PRINT "   3 - HIGHPASS"
390 PRINT "   4 - BANDSTOP"
400 INPUT "YOUR CHOICE";TYP
410 IF TYP=2 OR TYP=4 THEN 550
420 GOSUB 1990
430 'Atten at a given freq for lowpass filter
440 PRINT : INPUT "FREQUENCY AT WHICH TO CALCULATE ATTENUATION";FOFA
450 W=FOFA/BW3
460 IF TYP=3 THEN W=1/W
470 A=SQR(1+W^(2*NP))
480 ADB=20*LOG(A)/LOG(10)
490 PRINT "ATTENUATION AT";FOFA;D$;" IS";ADB;"dB"
500 Y$=""
510 PRINT : INPUT "CALCULATE ATTENUATION AT ANOTHER FREQUENCY (Y/N)";Y$
520 IF Y$="Y" OR Y$="y" THEN 440
530 GOTO 1960
540 'Atten at given freq for bandpass filter
550 PRINT : INPUT "CENTER FREQUENCY";FC
560 GOSUB 2350
570 GOSUB 1990
580 IF TYP=4 AND AORF=1 THEN PRINT "NOTE! - Frequency to be entered must not be the CENTER frequency"
590 PRINT : INPUT "FREQUENCY AT WHICH TO CALCULATE ATTENUATION";FOFA
600 FX=FC*FC/FOFA
610 BWX=ABS(FOFA-FX)
620 W=BWX/BW3
630 IF TYP=4 THEN W=1/W
640 A=SQR(1+W^(2*NP))
650 ADB=20*LOG(A)/LOG(10)
660 PRINT "ATTENUATION AT";FOFA;D$;" IS";ADB;"dB"
670 Y$=""
680 PRINT : INPUT "CALCULATE ATTENUATION AT ANOTHER FREQUENCY (Y/N)";Y$
690 IF Y$="Y" OR Y$="y" THEN 590
700 GOTO 1960
710 PRINT : PRINT "SELECT TYPE OF FILTER:"
720 PRINT "   1 - LOWPASS"
730 PRINT "   2 - BANDPASS"
740 PRINT "   3 - HIGHPASS"
750 PRINT "   4 - BANDSTOP"
760 INPUT "YOUR CHOICE";TYP
770 IF TYP=2 OR TYP=4 THEN 910
780 GOSUB 1990
790 'Freq for a given atten for lowpass filter
800 PRINT : INPUT "ATTENUATION IN dB";ADB
810 A=10^(ADB/20)
820 W=(A*A-1)^(1/(2*NP))
830 IF TYP=3 THEN W=1/W
840 FOFA=BW3*W
850 PRINT "ATTENUATION AT";FOFA;D$;" IS";ADB;"dB"
860 Y$=""
870 PRINT : INPUT "FIND FREQUENCY AT ANOTHER ATTENUATION (Y/N)";Y$
880 IF Y$="Y" OR Y$="y" THEN 800
890 GOTO 1960
900 'Freq at given atten for bandpass filter
910 PRINT : INPUT "CENTER FREQUENCY";FC
920 GOSUB 2350
930 GOSUB 1990
940 Y$=""
950 INPUT "ATTENUATION IN dB TO CALCULATE FREQUENCY";ADB
960 A=10^(ADB/20)
970 WX=(A*A-1)^(1/(2*NP))
980 BWX=BW3*WX
990 IF TYP=4 THEN BWX=BW3/WX
1000 FL=.5*(-BWX+SQR(BWX*BWX+4*FC*FC))
1010 IF FL<0 THEN 2330
1020 FH=FC*FC/FL
1030 PRINT 
1040 PRINT "AT ATTENUATION OF";ADB;"dB THE LOW FREQUENCY IS";FL;D$
1050 PRINT "AT ATTENUATION OF";ADB;"dB THE HIGH FREQUENCY IS";FH;D$
1060 PRINT : INPUT "FIND FREQUENCY AT ANOTHER ATTENUATION (Y/N)";Y$
1070 IF Y$="Y" OR Y$="y" THEN 940
1080 GOTO 1960
1090 PRINT CHR$(26);TAB(27);"CHEBYSHEV FILTER ANALYSIS"
1100 PRINT TAB(27);STRING$(25,"-")
1110 PRINT : INPUT "RIPPLE IN dB";R
1120 PRINT : PRINT  "ENTER RIPPLE CUTOFF FREQUENCY FOR LOWPASS AND HIGHPASS FILTERS"
1130 INPUT  "OR RIPPLE BANDWIDTH FOR BANDPASS AND BANDSTOP FILTERS           ",BWR
1140 PRINT : PRINT "DO YOU WANT PROGRAM TO CALCULATE:"
1150 PRINT "   1 - ATTENUATION FOR GIVEN FREQUENCY"
1160 PRINT "   2 - FREQUENCY FOR GIVEN ATTENUATION"
1170 INPUT "YOUR CHOICE";AORF
1180 IF AORF=2 THEN 1570
1190 PRINT : PRINT "SELECT TYPE OF FILTER:"
1200 PRINT "   1 - LOWPASS"
1210 PRINT "   2 - BANDPASS"
1220 PRINT "   3 - HIGHPASS"
1230 PRINT "   4 - BANDSTOP"
1240 INPUT "YOUR CHOICE";TYP
1250 IF TYP=2 OR TYP=4 THEN 1410
1260 GOSUB 1990
1270 'Atten at a given freq for lowpass filter
1280 PRINT : INPUT "FREQUENCY AT WHICH TO CALCULATE ATTENUATION";FOFA
1290 W=FOFA/BWR
1300 IF TYP=3 THEN W=1/W
1310 K=LOG(W+SQR(W*W-1))
1320 CN=.5*(EXP(NP*K)+EXP(-NP*K))
1330 A=SQR(1+(10^(.1*R)-1)*CN^2)
1340 ADB=20*LOG(A)/LOG(10)
1350 PRINT "ATTENUATION AT";FOFA;D$;" IS";ADB;"dB"
1360 Y$=""
1370 PRINT : INPUT "CALCULATE ATTENUATION AT ANOTHER FREQUENCY (Y/N)";Y$
1380 IF Y$="Y" OR Y$="y" THEN 1280
1390 GOTO 1960
1400 'Atten at given freq for bandpass filter
1410 PRINT : INPUT "CENTER FREQUENCY";FC
1420 GOSUB 1990
1430 PRINT : INPUT "FREQUENCY AT WHICH TO CALCULATE ATTENUATION";FOFA
1440 FX=FC*FC/FOFA
1450 BWX=ABS(FOFA-FX)
1460 W=BWX/BWR
1470 IF TYP=4 THEN W=1/W
1480 K=LOG(W+SQR(W*W-1))
1490 CN=.5*(EXP(NP*K)+EXP(-NP*K))
1500 A=SQR(1+(10^(.1*R)-1)*CN^2)
1510 ADB=20*LOG(A)/LOG(10)
1520 PRINT "ATTENUATION AT";FOFA;D$;" IS";ADB;"dB"
1530 Y$=""
1540 PRINT : INPUT "CALCULATE ATTENUATION AT ANOTHER FREQUENCY (Y/N)";Y$
1550 IF Y$="Y" OR Y$="y" THEN 1430
1560 GOTO 1960
1570 PRINT : PRINT "SELECT TYPE OF FILTER:"
1580 PRINT "   1 - LOWPASS"
1590 PRINT "   2 - BANDPASS"
1600 PRINT "   3 - HIGHPASS"
1610 PRINT "   4 - BANDSTOP"
1620 INPUT "YOUR CHOICE";TYP
1630 IF TYP=2 OR TYP=4 THEN 1790
1640 GOSUB 1990
1650 'Freq for a given atten for lowpass filter
1660 PRINT : INPUT "ATTENUATION IN dB";ADB
1670 A=10^(ADB/20)
1680 CN=SQR((A*A-1)/(10^(.1*R)-1))
1690 K=LOG(CN+SQR(CN*CN-1))
1700 W=.5*(EXP(K/NP)+EXP(-K/NP))
1710 IF TYP=3 THEN W=1/W
1720 FOFA=BWR*W
1730 PRINT : PRINT "FREQUENCY AT";ADB;"dB ATTENUATION IS";FOFA;D$
1740 Y$=""
1750 PRINT : INPUT "FIND FREQUENCY AT ANOTHER ATTENUATION (Y/N)";Y$
1760 IF Y$="Y" OR Y$="y" THEN 1660
1770 GOTO 1960
1780 'Freq at given atten for bandpass filter
1790 PRINT : INPUT "CENTER FREQUENCY";FC
1800 GOSUB 1990
1810 Y$=""
1820 INPUT "ATTENUATION IN dB TO CALCULATE FREQUENCY";ADB
1830 A=10^(ADB/20)
1840 CN=SQR((A*A-1)/(10^(.1*R)-1))
1850 K=LOG(CN+SQR(CN*CN-1))
1860 W=.5*(EXP(K/NP)+EXP(-K/NP))
1870 IF Q=1 THEN BWX=BWR*W ELSE BWX=BW3*W
1880 IF TYP=4 THEN BWX=BWR/W
1890 FL=.5*(-BWX+SQR(BWX*BWX+4*FC*FC))
1900 FH=FC*FC/FL
1910 PRINT 
1920 PRINT "AT ATTENUATION OF";ADB;"dB THE LOW FREQUENCY IS";FL;D$
1930 PRINT "AT ATTENUATION OF";ADB;"dB THE HIGH FREQUENCY IS";FH;D$
1940 PRINT : INPUT "FIND FREQUENCY AT ANOTHER ATTENUATION (Y/N)";Y$
1950 IF Y$="Y" OR Y$="y" THEN 1810
1960 INPUT "RUN PROGRAM AGAIN (Y/N)";Y$
1970 IF Y$="Y" OR Y$="y" THEN 40
1980 END
1990 'Header subroutine
2000 IF NUM=1 AND (TYP=1 OR TYP=3) THEN B$=" 3 dB CUTOFF FREQUENCY ="
2010 IF NUM=1 AND (TYP=2 OR TYP=4) THEN B$=" 3 dB BANDWIDTH ="
2020 IF NUM=2 AND (TYP=1 OR TYP=3) THEN B$=" RIPPLE CUTOFF FREQUENCY ="
2030 IF NUM=2 AND (TYP=2 OR TYP=4) THEN B$=" RIPPLE BANDWIDTH ="
2040 D$="Hz"
2050 IF HZ=2 THEN D$="kHz"
2060 IF HZ=3 THEN D$="MHz"
2070 IF HZ=4 THEN D$="GHz"
2080 A$="LOWPASS"
2090 IF TYP=2 THEN A$="BANDPASS"
2100 IF TYP=3 THEN A$="HIGHPASS"
2110 IF TYP=4 THEN A$="BANDSTOP"
2120 IF NUM=2 THEN C$="CHEBYSHEV" ELSE C$="BUTTERWORTH"
2130 IF NUM=2 THEN BW3=BWR
2140 IF NUM=2 AND (TYP=2 OR TYP=4) THEN GOSUB 2350
2150 PRINT CHR$(26)
2160 PRINT NP;"POLE ";C$;" ";A$;" FILTER"
2170 IF NUM=2 THEN PRINT " RIPPLE =";R;"dB"
2180 IF TYP=2 OR TYP=4 THEN PRINT " CENTER FREQUENCY =";FC;D$
2190 IF TYP=1 OR TYP=3 THEN PRINT B$;BW3;D$
2200 IF TYP=2 OR TYP=4 THEN PRINT B$;BW3;D$;" (";FML;"TO";FMH;D$;" )"
2210 PRINT : PRINT STRING$(78,"*") : PRINT 
2220 IF NUM=2 AND AORF=1 AND TYP=2 THEN PRINT "NOTE! - Frequency to be entered must not be within bandwidth of filter" : PRINT 
2230 IF NUM=2 AND AORF=1 AND TYP=4 THEN PRINT "NOTE! - Frequency to be entered must be within stopband of filter,"
2240 IF NUM=2 AND AORF=1 AND TYP=4 THEN PRINT "        but cannot be CENTER frequency"
2250 IF NUM=2 AND AORF=1 AND TYP=1 THEN PRINT "NOTE! - Frequency to be entered must not be lower than cutoff frequency" : PRINT 
2260 IF NUM=2 AND AORF=1 AND TYP=3 THEN PRINT "NOTE! - Frequency to be entered must not be higher than cutoff frequency" : PRINT 
2270 IF NUM=2 AND AORF=2 THEN PRINT "NOTE! - Attenuation to be entered must not be less than ripple" : PRINT 
2280 IF NUM=1 AND AORF=2 AND (TYP=3 OR TYP=4) THEN PRINT "NOTE! - Attenuation to be entered must not be 0 dB" : PRINT
2290 RETURN
2300 'Error messages
2310 PRINT : PRINT "YOU HAVE ENTERED AN INVALID VALUE";CHR$(7)
2320 RESUME 1960
2330 PRINT : PRINT "YOU HAVE ENTERED AN INVALID VALUE";CHR$(7)
2340 GOTO 1960
2350 'Mean freq and actual bandwidth subroutine
2360 F1=FC-BW3/2
2370 F2=FC+BW3/2
2380 FM=SQR(F1*F2)
2390 FM=2*FC-FM
2400 FML=FM-BW3/2
2410 FMH=FM+BW3/2
2420 RETURN
e
2360 F1=FC-BW3/2
2370 F2=FC+BW3/2
2380 FM=SQR(F1