10 '   -------> MOON.BAS <---------
20 '   Rev. F, 20 Sep 85, N6TX . . . MICROSOFT BASIC
30 '   MOON LOCATION PROGRAM BY N6TX, BASED UPON THE WA1JXN
40 '   BASIC PROGRAM OF MARCH, 1974 (See EIMAC AS-49-6 p.8)
50 '   ----------------------------------------------------
60 DEF FNC$(B)=CHR$(48+INT(B/1000))
70 DEF FND$(B)=CHR$(48+INT(B/100)-10*INT(B/1000))
80 DEF FNE$(B)=CHR$(48+INT(B/10)-10*INT(B/100))
90 DEF FNF$(B)=CHR$(48+B-10*INT(B/10))
100 DEF FNG$(B)=FNC$(B)+FND$(B)+FNE$(B)+FNF$(B)
110 DEF FNA(X)=INT(X*D5*10+.5)/10
120 DEF FNB(X)=(X-INT(X))*P5
130 P5=2#*3.141592653500022#
140 D5=360/P5
150 R5=P5/360
160 CLS$ = CHR$(26)
170 '  -------------------------------
180 '  DEFINE DEFAULT USER COORDINATES
190 C$  ="W6NBI"
200 L5  =  37.34
210 L6  =  122.07
220 '  ---------------------   
230 '  BEGIN CONTROL PROGRAM
240 PRINT CLS$
250 PRINT "'MOON' IS THE WA1JXN MOON-TRACKING PROGRAM,"
260 PRINT "     MODIFIED BY N6TX TO RUN UNDER MICROSOFT BASIC"
270 PRINT "     ON THE OSBORNE ONE COMPUTER, WITH PROMPTS ON"
280 PRINT "     SCREEN, AND OUTPUT TO SCREEN OR PRINTER."
290 PRINT : PRINT "Follow all data entries with a Carriage Return." : PRINT
300 PRINT : PRINT  "DEFAULT STATION IS:"
310 PRINT TAB(15); C$; TAB(25); L5;"  Deg. NORTH,  ";L6;"  Deg. WEST"
320 PRINT
330 PRINT "To make a PERMANENT change, enter your STATION ID in LINE 190,"
340 PRINT "   your LATITUDE in LINE 200, and your LONGITUDE  in LINE 210"
350 PRINT "   of the program source code."
360 PRINT
370 INPUT "Do you wish to make a TEMPORARY change (Y/N)  ";D$
380 IF D$="Y" OR D$="y" THEN GOSUB 2530
390 PRINT CLS$
400 L5=L5*R5
410 L6=L6*R5
420 GOSUB 2450
430 PRINT
440 INPUT "DESIRED TIME STEP, IN MINUTES " ; I
450 PRINT : PRINT "DO YOU WANT OUTPUT ONLY WHEN THE MOON IS"
460 INPUT "          NEAR THE HORIZON (Y/N) " ; B$
470 IF B$="Y" OR B$="YES" OR B$="y" OR B$="yes" THEN 500
480 I6=100
490 GOTO 560
500 PRINT : PRINT "BELOW WHAT ELEVATION, IN DEGREES, DO YOU WISH"
510 INPUT "        TO DISPLAY DATA " ; I6
520 GOSUB 2130
530 E1=2400
540 B=0
550 GOTO 660
560 GOSUB 2130
570          INPUT "         START (GMT hhmm)  ";B
580          INPUT "         STOP  (GMT hhmm)  ";E1
590 IF B>2400 OR E1>2400 THEN 600 ELSE 630
600 PRINT : PRINT "Time must be between 0000 and 2400 GMT."
610 PRINT "            Try again, please." : PRINT
620 GOTO 570
630 IF B<E1 THEN 660
640 PRINT : PRINT "Stop time must be later than Start time."
650 GOTO 610
660 IF PR$="S" OR PR$="s" THEN 760
670 LPRINT
680 LPRINT "         MOON TRACKING DATA FOR  " ; C$
690 LPRINT "LATITUDE ";L5/R5;" Deg. N,   LONGITUDE ";L6/R5;" Deg. W."
700 LPRINT:LPRINT "DATA FOR  ";D;M$;Y;"   FROM   ";
710 LPRINT FNG$(B);"   TO   ";FNG$(E1);"   GMT"
720 LPRINT
730 LPRINT" GMT";TAB(12)"AZ";TAB(24)"EL";TAB(36)"GHA";TAB(48)"DEC";TAB(60)"WINDOW"
740 LPRINT" ---";TAB(12)"--";TAB(24)"--";TAB(36)"---";TAB(48)"---";TAB(60)"------"
750 LPRINT
760 PRINT CLS$;"DATA FOR ";D;M$;Y;"  FROM ";FNG$(B);" TO ";FNG$(E1);" GMT":PRINT
770 PRINT" GMT";TAB(9)"AZ";TAB(18)"EL";TAB(27)"GHA";TAB(36)"DEC";TAB(45)"WINDOW"
780 PRINT" ---";TAB(9)"--";TAB(18)"--";TAB(27)"---";TAB(36)"---";TAB(45)"------"
790 I1=2
800 '   --------------------------------------
810 '   HERE BEGINS CALCULATION OF JULIAN DATE
820 IF M>=3 THEN 900
830 IF INT((Y-1853)/4)<11 THEN 860
840 C1=-1
850 GOTO 870
860 C1=0
870 J1=365*(Y-1853)+D+30*(M+9)+INT((M+10)/2)
880 J2=INT((Y-1853)/4)+1+C1
890 GOTO 1010
900 IF INT((Y-1852)/4)<11 THEN 930
910 C1=-1
920 GOTO 940
930 C1=0
940 IF M=9 THEN 980
950 IF M=11 THEN 980
960 C2=0
970 GOTO 990
980 C2=1
990 J1=365*(Y-1852)+D+30*(M-3)+INT((M-2)/2)
1000 J2=INT((Y-1852)/4)+C1+C2
1010 J=J1+J2
1020 '   (JULIAN DATE-2397547.5) FOR 0 HOURS GMT
1030 T1=J-17472.5
1040 D9=(B-INT(B/100)*100)+INT(B/100)*60
1050 D6=(E1-INT(E1/100)*100)+INT(E1/100)*60
1060 D7=D9-D6
1070 D8=D7-I
1080 IF D7>0 THEN 1100
1090 GOTO 1120
1100 IF D8>=0 THEN 2090
1110 B=E1
1120 T=(B-INT(B/100)*100)/1440+INT(B/100)/24
1130 T5=T1+T
1140 K1=FNB(.751213+.03660110200000019#*T5)
1150 K2=FNB(.822513+.0362916457#*T5)
1160 K3=FNB(.995766+.00273777852#*T5)
1170 K4=FNB(.974271+.03386319570000008#*T5)
1180 K5=FNB(.0312525+.0367481957#*T5)
1190 L8=K1+.658*R5*SIN(2*K4)+6.289*R5*SIN(K2)
1200 L8=L8-1.274*R5*SIN(K2-2*K4)-.186*R5*SIN(K3)
1210 L8=L8+.214*R5*SIN(2*K2)-.114*R5*SIN(2*K5)
1220 L8=L8-.059*R5*SIN(2*K2-2*K4)-.057*R5*SIN(K2+K3-2*K4)
1230 K6=K5+.6593*R5*SIN(2*K4)+6.2303*R5*SIN(K2)-1.272*R5*SIN(K2-2*K4)
1240 L7=5.144*R5*SIN(K6)-.146*R5*SIN(K5-2*K4)
1250 D1=COS(L7)*SIN(L8)*.397821+SIN(L7)*.917463
1260 D1=ATN(D1/(SQR(1-D1^2)))
1270 G1=50.5+((D1)/(.792))*D5
1280 G2=80+((D1)/(.808))*D5
1290 G3=141.5-((D1)*(.768)*D5)
1300 G4=170.5-((D1)*(.857)*D5)
1310 A2=COS(L7)*COS(L8)/COS(D1)
1320 A1=(COS(L7)*SIN(L8)*.917463-SIN(L7)*.397821)/COS(D1)
1330 A=ATN(A1/A2)
1340 GOSUB 1600
1350 R1=A
1360 L1=.06570982200000002#*T1
1370 L=T*24*1.00274+6.64606+(L1-INT(L1/24)*24)
1380 L=(L-INT(L/24)*24)
1390 G=(L/24)*P5-R1
1400 IF G<P5 THEN 1430
1410 G=G-P5
1420 GOTO 1460
1430 IF G<0 THEN 1450
1440 GOTO 1460
1450 G=G+P5
1460 H=L6-G
1470 E3=COS(L5)*COS(H)*COS(D1)+SIN(D1)*SIN(L5)
1480 E2=SQR(1-(E3^2))
1490 E=ATN(E3/E2)
1500 IF E<0 THEN 2040
1510 IF E>I6*R5 THEN 2040
1520 A2=SIN(D1)/(COS(L5)*COS(E))
1530 A2=A2-(SIN(L5)/COS(L5))*(SIN(E)/COS(E))
1540 A1=SIN(L5)*SIN(D1)+COS(L5)*COS(D1)*COS(H)
1550 A1=(SIN(H)*COS(D1))/(SQR(1-A1^2))
1560 A=ATN(A1/A2)
1570 GOSUB 1600
1580 GOTO 1750
1590 '  
1600 IF A=0 THEN 1620
1610 GOTO 1660
1620 IF A2<0 THEN 1640
1630 GOTO 1740
1640 A=P5/2
1650 GOTO 1740
1660 IF A>0 THEN 1720
1670 IF A2<0 THEN 1700
1680 A=P5+A
1690 GOTO 1740
1700 A=P5+(A-P5/2)
1710 GOTO 1740
1720 IF A2>=0 THEN 1740
1730 A=A+P5/2
1740 RETURN
1750 IF(T-I1)>(2*I)/1440 THEN 1770
1760 GOTO 1800
1770 IF PR$="S" THEN 1790
1780 LPRINT
1790 PRINT
1800 IF FNA(D1)<0 THEN 1930
1810 IF FNA(G)<G1 THEN 1930
1820 IF FNA(G)>G2 THEN 1840
1830 GOTO 1870
1840 IF FNA(G)<G3 THEN 1890
1850 IF FNA(G)>G4 THEN 1930
1860 GOTO 1910
1870 S$=" European"
1880 GOTO 1940
1890 S$=" N. Amer."
1900 GOTO 1940
1910 S$=" Asian   "
1920 GOTO 1940
1930 S$="   "
1940 IF PR$="S" OR PR$="s" THEN 1990
1950 LPRINT FNG$(INT(B+.5));
1960 LPRINT TAB(11)
1970 LPRINT USING "###          ##         ###.#       ###.#";FNA(A),FNA(E),FNA(G),FNA(D1);
1980 LPRINT TAB(58)S$
1990 PRINT FNG$(INT(B+.5));
2000 PRINT TAB(8)
2010 PRINT USING "###       ##      ###.#   ###.#";FNA(A),FNA(E),FNA(G),FNA(D1);
2020 PRINT TAB(44)S$
2030 I1=T
2040 B=B+I
2050 Z=(B-INT(B/100)*100)-60
2060 IF Z<0 THEN 1040
2070 B=INT(B/100)*100+100+Z
2080 GOTO 1040
2090 PRINT : INPUT "Type <cr> for more data, N <cr> to quit.       ";D$
2100 IF D$="N" OR D$="n" THEN 2640 ELSE 420
2110 '    ----------------------------
2120 '    SUBROUTINE FOR ENTERING DATE
2130 PRINT CLS$
2140 PRINT "ENTER THE DATE FOR WHICH YOU DESIRE DATA HERE:"
2150 PRINT : PRINT"             numbers only, please"
2160 PRINT
2170         INPUT "         MONTH (1 -12)     ";M
2180         INPUT "         DAY   (1 -31)     ";D
2190         INPUT "         YEAR  (00-99)     ";Y1
2200 Y=Y1+1900
2210 IF Y1>100 THEN 2250
2220 IF M<1 OR M>12 THEN 2250
2230 IF D<1 OR D>31 THEN 2250
2240 GOTO 2270
2250 PRINT : PRINT "You have entered a non-valid date.  Try again."
2260 GOTO 2150
2270 GOSUB 2300
2280 RETURN
2290 '  ----------------------------------------------
2300 '  SUBROUTINE FOR ASSIGNING ALPHA STRING TO MONTH
2310 IF M=1 THEN M$="JAN"
2320 IF M=2 THEN M$="FEB"
2330 IF M=3 THEN M$="MAR"
2340 IF M=4 THEN M$="APR"
2350 IF M=5 THEN M$="MAY"
2360 IF M=6 THEN M$="JUN"
2370 IF M=7 THEN M$="JUL"
2380 IF M=8 THEN M$="AUG"
2390 IF M=9 THEN M$="SEP"
2400 IF M=10 THEN M$="OCT"
2410 IF M=11 THEN M$="NOV"
2420 IF M=12 THEN M$="DEC"
2430 RETURN
2440 '  ---------------------------------------------
2450 '  SUBROUTINE TO SELECT PRINTER OR SCREEN OUTPUT
2460 PRINT CLS$
2470 PRINT "DO YOU PREFER TO HAVE OUTPUT ROUTED TO"
2480 INPUT "     PRINTER (P), OR SCREEN (S) "; PR$
2490 IF PR$="P" OR PR$="p" OR PR$="s" OR PR$="S" THEN RETURN
2500 PRINT : PRINT "You have made an invalid selection.  Try again." : PRINT
2510 GOTO 2470
2520 '  -----------------------------------------  
2530 '  SUBROUTINE TO CHANGE DEFAULT STATION DATA
2540 PRINT : PRINT "ENTER YOUR STATION LOCATION HERE:" : PRINT
2550 INPUT "     STATION CALL LETTERS  " ; C$
2560 INPUT "     LATITUDE (DEG. NORTH) " ; L5
2570 INPUT "     LONGITUDE (DEG. WEST) " ; L6
2580 IF L5<-90 OR L5>90 OR L6<-180 OR L6>180 THEN 2590 ELSE RETURN
2590 PRINT : PRINT "You have made an error.  Please try again."
2600 PRINT "Latitude  must be between  -90 and  +90 degrees;"
2610 PRINT "Longitude must be between -180 and +180 degrees."
2620 PRINT "South Latitude or East Longitude is Negative.": PRINT
2630 GOTO 2560
2640 END
 between -180 and +180 degrees."
262