10 '   -------> SUN.BAS <---------
20 '   Rev. B, 20 Sep 85, N6TX . . . MICROSOFT BASIC
30 '   SUN LOCATION PROGRAM BY W4WD, MODIFIED BY N6TX.
40 '   BASED UPON THE WA1JXN MOON-TRACKING PROGRAM OF  
50 '   MARCH, 1974.  (See EIMAC AS-49-6 p.8)
60 ' ------------------------------------------------
70 DEF FNC$(B)=CHR$(48+INT(B/1000))
80 DEF FND$(B)=CHR$(48+INT(B/100)-10*INT(B/1000))
90 DEF FNE$(B)=CHR$(48+INT(B/10)-10*INT(B/100))
100 DEF FNF$(B)=CHR$(48+B-10*INT(B/10))
110 DEF FNG$(B)=FNC$(B)+FND$(B)+FNE$(B)+FNF$(B)
120 DEF FNA(X)=INT(X*10+.5)/10
130 P5=2#*3.141592653500028#
140 D5=360/P5
150 R5=P5/360
160 CLS$ = CHR$(26)                ' Defines Clear-Screen string
170 ' -------------------------------
180 ' DEFINE DEFAULT USER COORDINATES
190 C$  ="W6NBI"
200 L5  =  37.34
210 L6  =  122.07
220 '  ---------------------
230 '  BEGIN CONTROL PROGRAM
240 PRINT CLS$    
250 PRINT "'SUN' IS THE WA1JXN MOON-TRACKING PROGRAM,"
260 PRINT "     MODIFIED BY W4WD TO TRACK THE SUN, AND FURTHER"
270 PRINT "     MODIFIED BY N6TX TO RUN UNDER MICROSOFT BASIC"
280 PRINT "     ON THE OSBORNE ONE COMPUTER, WITH PROMPTS ON"
290 PRINT "     SCREEN, AND OUTPUT TO SCREEN OR PRINTER."
300 PRINT : PRINT "Follow all data entries with a Carriage Return." : PRINT
310 PRINT : PRINT "DEFAULT STATION IS:"
320 PRINT TAB(15); C$; TAB(25); L5; "  Deg. NORTH,  "; L6; "  Deg. WEST"
330 PRINT
340 PRINT "To make a PERMANENT change, enter your STATION ID in LINE 190,"
350 PRINT "   your LATITUDE in LINE 200, and your LONGITUDE  in LINE 210"
360 PRINT "   of the program source code."
370 PRINT
380 INPUT "Do you wish to make a TEMPORARY change (Y/N)  "; D$
390 IF D$ = "Y" OR D$ = "y" THEN GOSUB 1900
400 PRINT CLS$
410 L5=L5*R5
420 SL = SIN(L5)
430 CL = COS(L5)
440 L6=L6*R5
450 GOSUB 1820          ' output to printer or screen
460 PRINT
470 INPUT "DESIRED TIME STEP, IN MINUTES " ; I
480 GOSUB 1510          ' date entry subroutine
490          INPUT "         START (GMT hhmm)  ";B
500          INPUT "         STOP  (GMT hhmm)  ";E1
510 IF B>2400 OR E1>2400 THEN 520 ELSE 550
520 PRINT : PRINT "Time must be between 0000 and 2400 GMT."
530 PRINT "            Try again, please." : PRINT
540 GOTO 490
550 IF B<E1 THEN 580
560 PRINT : PRINT "Stop time must be later than Start time."
570 GOTO 530
580 IF PR$="S" OR PR$="s" THEN 680
590 LPRINT
600 LPRINT "          SUN TRACKING DATA FOR  " ; C$
610 LPRINT "LATITUDE ";L5/R5;" Deg. N,   LONGITUDE ";L6/R5;" Deg. W."
620 LPRINT:LPRINT "DATA FOR  ";D;M$;Y;"   FROM   ";
630 LPRINT FNG$(B);"   TO   ";FNG$(E1);"   GMT"
640 LPRINT
650 LPRINT" GMT";TAB(12)"AZ";TAB(24)"EL";TAB(36)"GHA";TAB(48)"DEC"
660 LPRINT" ---";TAB(12)"--";TAB(24)"--";TAB(36)"---";TAB(48)"---"
670 LPRINT
680 PRINT CLS$
690 PRINT "DATA FOR ";D;M$;Y;"  FROM ";FNG$(B);" TO ";FNG$(E1);" GMT"
700 PRINT
710 PRINT" GMT";TAB(9)"AZ";TAB(18)"EL";TAB(27)"GHA";TAB(36)"DEC"
720 PRINT" ---";TAB(9)"--";TAB(18)"--";TAB(27)"---";TAB(36)"---"
730 I1=2
740 '                          HERE BEGINS CALCULATION OF JULIAN DATE
750 J1 = 367*Y-INT(7*(Y+INT((M+9)/12))/4)+INT(275*M/9)+D
760 J2 = 1721013.5#-.5*SGN(100*Y+M-190003!)+.5
770 JD = J1+J2
780 '
790 D9=(B-INT(B/100)*100)+INT(B/100)*60
800 D6=(E1-INT(E1/100)*100)+INT(E1/100)*60
810 D7=D9-D6
820 D8=D7-I
830 IF D7>0 THEN 850
840 GOTO 870
850 IF D8>=0 THEN 1490
860 B=E1
870 B2 = INT(B/100) + (B-INT(B/100)*100) / 60
880 B1 = B2 / 24
890 JT = JD + B1
900 T = (JT - 2.41502E+06) / 36525!
910 MS = 358.476 + 35999.1 * T
920 L = 279.691 + 36000.769# * T
930 LS = L + (1.919-.0048*T) * SIN(MS/D5) + .02*SIN(2*MS/D5)
940 IF LS>360 THEN LS = LS-360
950 IF LS>360 THEN GOTO 940
960 EP = 23.452 - .013 * T
970 TR = COS(EP/D5)*TAN(LS/D5)
980 SD = SIN(EP/D5) * SIN(LS/D5)
990 RA = ATN(TR)*D5
1000 IF RA<0 THEN RA = RA+180
1010 IF ABS(LS-RA) > 90 THEN RA = RA+180
1020 IF RA>360 THEN RA = RA-360
1030 DE = ATN(SD/SQR(-SD*SD+1))
1040 CD = COS(DE)
1050 D1 = DE*D5
1060 L1 = .06570982200000002# * (JD - 2444604.5#)
1070 GM = 1.0027379093# * B2+6.63832+L1
1080 IF GM>24 THEN GM = GM-24
1090 IF GM>24 THEN GOTO 1080
1100 OM = 372.113 - .0529539 * (JT - 2444604.5#)
1110 EE = .00029*SIN(OM/D5)
1120 GA = GM + EE
1130 G = GA*15-RA
1140 IF G<0 THEN G = G + 360
1150 LH = G - L6 * D5
1160 SH = SIN(LH/D5)
1170 CH = COS(LH/D5)
1180 SA = SL * SD + CL * CD * CH
1190 E = ATN(SA/SQR(-SA*SA+1))*D5
1200 IF E<0 THEN 1430
1210 A2 = SD/(CL * COS(E/D5))
1220 A2 = A2 - (SL/CL) * (SIN(E/D5)/COS(E/D5))
1230 A1 = (SH*CD) / (SQR(1-SA^2))
1240 A = D5 * (ATN(A1/A2))
1250 IF G = L6 * D5 THEN A = 180
1260 IF G < L6 * D5 AND SGN(A) > 0 THEN A = 180 - A
1270 IF G < L6 * D5 AND SGN(A) < 0 THEN A = -A
1280 IF G > L6 * D5 AND SGN(A) < 0 THEN A = A + 180
1290 IF G > L6 * D5 AND SGN(A) > 0 THEN A = 360 - A
1300 IF(T-I1)>(2*I)/1440 THEN 1320
1310 GOTO 1350
1320 IF PR$="S" OR PR$="s" THEN 1340   
1330 LPRINT
1340 PRINT
1350 IF PR$="S" OR PR$="s" THEN 1390
1360 LPRINT FNG$(INT(B+.5));
1370 LPRINT TAB(11)
1380 LPRINT USING "###          ##         ###.#       ###.#";FNA(A),FNA(E),FNA(G),FNA(D1)
1390 PRINT FNG$(INT(B+.5));
1400 PRINT TAB(8)
1410 PRINT USING "###       ##      ###.#   ###.#";FNA(A),FNA(E),FNA(G),FNA(D1)
1420 I1=T
1430 B=B+I
1440 Z=(B-INT(B/100)*100)-60
1450 IF Z<0 THEN 790
1460 B=INT(B/100)*100+100+Z
1470 GOTO 790
1480 ' -------------  "CONTINUE" Subroutine  ---------------------
1490 PRINT : INPUT "Type <cr> for more data, Q <cr> to quit.       ";D$
1500 IF D$="Q" OR D$="q" THEN 2010 ELSE 450
1510 ' -----------   SUBROUTINE FOR ENTERING DATE  -------------
1520 PRINT CLS$    
1530 PRINT "ENTER THE DATE FOR WHICH YOU DESIRE DATA HERE:"
1540 PRINT : PRINT"             numbers only, please"
1550 PRINT
1560         INPUT "         MONTH (1 -12)     ";M
1570         INPUT "         DAY   (1 -31)     ";D
1580         INPUT "         YEAR  (00-99)     ";Y1
1590 Y=Y1+1900
1600 IF Y1>100 THEN 1640
1610 IF M<1 OR M>12 THEN 1640
1620 IF D<1 OR D>31 THEN 1640
1630 GOTO 1660
1640 PRINT : PRINT "You have entered a non-valid date.  Try again."
1650 GOTO 1540
1660 GOSUB 1680
1670 RETURN
1680 ' --------  SUBROUTINE FOR ASSIGNING ALPHA STRING TO MONTH  ------
1690 IF M=1 THEN M$="JAN"
1700 IF M=2 THEN M$="FEB"
1710 IF M=3 THEN M$="MAR"
1720 IF M=4 THEN M$="APR"
1730 IF M=5 THEN M$="MAY"
1740 IF M=6 THEN M$="JUN"
1750 IF M=7 THEN M$="JUL"
1760 IF M=8 THEN M$="AUG"
1770 IF M=9 THEN M$="SEP"
1780 IF M=10 THEN M$="OCT"
1790 IF M=11 THEN M$="NOV"
1800 IF M=12 THEN M$="DEC"
1810 RETURN
1820 ' ----------  SUBROUTINE TO SELECT PRINTER OR SCREEN OUTPUT  --------
1830 PRINT CLS$    
1840 PRINT "DO YOU PREFER TO HAVE OUTPUT ROUTED TO"
1850 INPUT "     PRINTER (P), OR SCREEN (S) "; PR$
1860 IF PR$="P" OR PR$="p" OR PR$="S" OR PR$="s" THEN RETURN
1870 PRINT : PRINT "You have made an invalid selection.  Try again." : PRINT
1880 GOTO 1840
1890 '  -----------------------------------------
1900 '  SUBROUTINE TO CHANGE DEFAULT STATION DATA
1910 PRINT : PRINT "ENTER YOUR STATION LOCATION HERE:" : PRINT
1920 INPUT "     STATION CALL LETTERS          " ; C$
1930 INPUT "     LATITUDE (DECIMAL DEG. NORTH) " ; L5
1940 INPUT "     LONGITUDE (DECIMAL DEG. WEST) " ; L6
1950 IF L5<-90 OR L5>90 OR L6<-180 OR L6>180 THEN 1960 ELSE RETURN
1960 PRINT : PRINT "You have made an error.  Please try again."
1970 PRINT "Latitude  must be between  -90 and  +90 degrees;"
1980 PRINT "Longitude must be between -180 and +180 degrees."
1990 PRINT "South Latitude or East Longitude is Negative.": PRINT
2000 GOTO 1930
2010 END
 between -180 and +180 degrees."
1990 PRINT