10 PRINT CHR$(26) : PRINT TAB(25);"TWO-COLUMN PRINTING"
20 'Written by Ralph Landry as WSTWOCOL.BAS
30 'Converted to MBASIC, renamed, and enhanced by R. S. Stein, 4/23/86
40 PRINT
50 PRINT "   This program takes a text file and makes a two-column format."
60 PRINT "The text file must first be formatted into a column width (typically"
70 PRINT "30 to 35 characters) so that two columns can be fitted side by side."
80 PRINT "   If the text file was created by WordStar, you must also strip the"
90 PRINT "file so that all control codes are removed."
100 PRINT "   The program writes out files COL1 and COL2, merges both files into"
110 PRINT "one called COLUMN2.PRT, and then erases COL1 and COL2.  (Be sure you"
120 PRINT "have enough room for these files on your disk.)"
130 CTR1%=0 : CTR2%=0 : CTR%=0 : WID%=35 : GUTR%=5 : LNG%=55
140 FCTR%=0 : COL%=0 : XCS%=0 : FMT%=0 : PCTR%=0 : SHRT%=0
150 PRINT : PRINT "THE PROGRAM WILL FORMAT AS FOLLOWS:"
160 PRINT "     1 - COLUMN WIDTH =";WID%
170 PRINT "     2 - SPACE BETWEEN COLUMNS =";GUTR%
180 PRINT "     3 - LINES PER COLUMN =";LNG%
190 PRINT : PRINT "PRESS <CR> TO KEEP THE ABOVE UNCHANGED OR"
200 INPUT "ENTER THE NUMBER OF THE ITEM TO BE CHANGED ",C%
210 IF C%=0 THEN 290
220 IF C%<1 OR C%>3 THEN PRINT "Please enter a number between 1 and 3":GOTO 190 
230 ON C% GOTO 240,250,260
240 INPUT "ENTER COLUMN WIDTH ",WID% : GOTO 270
250 INPUT "ENTER SPACE BETWEEN COLUMNS ",GUTR% : GOTO 270
260 INPUT "ENTER LINES PER COLUMN ",LNG%
270 PRINT : INPUT "ANY MORE CHANGES? (Y/N)";C$
280 IF C$="Y" OR C$="y" THEN 150 
290 PRINT 
300 LINE INPUT "ENTER THE FILE NAME TO CONVERT  ";F$
310 ON ERROR GOTO 900
320 OPEN"I",1,F$				'Count lines in text file
330 IF EOF(1) THEN 370
340 LINE INPUT #1,A$
350 FCTR%=FCTR%+1				'No. of lines in text file
360 GOTO 330
370 CLOSE
380 COL%=FCTR%\LNG%				'No. of full columns
390 XCS%=FCTR% MOD LNG%				'No. of lines on last page
400 IF COL%/2=INT(COL%/2) THEN FMT%=1 ELSE FMT%=2
410 OPEN"I",1,F$
420 OPEN"O",2,"COL1"
430 OPEN"O",3,"COL2"
440 PRINT CHR$(26) : PRINT "MAKING COLUMNS..."
450 IF EOF(1) THEN 610
460 CTR1%=CTR1%+1
470 LINE INPUT #1,A$
480 IF EOF(1) THEN PCTR%=PCTR%+1 : PRINT #2,A$+CHR$(12) ELSE PRINT #2,A$
490 IF PCTR%<>INT(COL%/2) THEN 520
500 IF FMT%=1 THEN SHRT%=INT(XCS%/2+.5) ELSE SHRT%=INT((XCS%+LNG%)/2+.5)
510 IF CTR1%=SHRT% THEN CTR2%=0 : GOTO 540
520 IF CTR1%=LNG% THEN CTR2%=0 : PCTR%=PCTR%+1 : GOTO 540
530 GOTO 450
540 IF EOF(1) THEN 610
550 CTR2%=CTR2%+1
560 LINE INPUT #1,A$
570 PRINT #3,A$
580 IF PCTR%=INT(COL%/2) AND CTR2%=SHRT% THEN CTR1%=0 : GOTO 450
590 IF CTR2%=LNG% THEN CTR1%=0 : GOTO 450
600 GOTO 540
610 CLOSE
620 OPEN"I",1,"COL1"
630 OPEN"I",2,"COL2"
640 OPEN"O",3,"COLUMN2.PRT"
650 PRINT CHR$(26)
660 IF EOF(1) THEN 770
670 CTR%=CTR%+1
680 LINE INPUT #1,A$
690 IF EOF(2) THEN B$="" : GOTO 710
700 LINE INPUT #2,B$
710 PRINT #3,A$;TAB(WID%+GUTR%+1);B$
720 PRINT A$;TAB(WID%+GUTR%+1);B$
730 IF CTR%=LNG% THEN CTR%=0 ELSE 660
740 PRINT #3,CHR$(12)
750 PRINT : PRINT : PRINT 
760 GOTO 660
770 CLOSE
780 KILL "COL1" : KILL "COL2"
790 PRINT CHR$(26)
800 PRINT "COLUMNS FINISHED --"
810 PRINT : PRINT "Now you can print out the file COLUMN2.PRT by one of the following methods:"
820 PRINT 
830 PRINT "   (1) In CP/M, enter 'TYPE COLUMN2.PRT' CTRL-P <CR>"
840 PRINT : PRINT "   (2) Use WordStar and answer 'Y' to 'USE FORM FEEDS' and"
850 PRINT "       'SUPPRESS PAGE FORMATTING' questions in the PRINT menu"
860 PRINT : PRINT "In either case, page numbers will not be printed unless they"
870 PRINT "are added using a word processor (see TXT2COL.DOC)."
880 PRINT : PRINT "ENJOY THE PROGRAM!"
890 END
900 'If text file cannot be found:
910 IF ERR=53 AND ERL=320 THEN PRINT "     Text file not on disk!"  ELSE 930
920 RESUME 290
930 'If any other error, halt execution:
940 ON ERROR GOTO 0
GOTO 710
700 LINE INPUT #2,B$
710 PRINT #3,A$;TAB(WID%+GUTR%+1);B$
